<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/09/2008 *
 * ===============                              Last change: 09/09/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : load_cache-config.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Load more cache files                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mehr Cache-Dateien nachladen                     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} // END - if

// Let's start with the admins table...
if (($cacheInstance->cache_file("admins")) && ($cacheInstance->ext_version_matches("admins"))) {
	// Load cache
	global $cacheArray;
	$cacheArray['admins'] = $cacheInstance->cache_load();

	// Check if valid
	if ((is_array($cacheArray['admins']['login'])) && (is_array($cacheArray['admins']['aid']))) {
		// Check count
		if (count($cacheArray['admins']['login']) == count($cacheArray['admins']['aid'])) {
			// Get "id map"
			$idMap = $cacheArray['admins']['aid'];

			// Rewrite the cache array
			for ($idx = (count($idMap) - 1); $idx >= 0; $idx--) {
				// Rewrite all entries
				foreach ($cacheArray['admins'] as $key=>$entryArray) {
					// Rewrite the entry
					if ($key == "aid") {
						// Rewrite admin id (use login name as index)
						$cacheArray['admins']['aid'][$cacheArray['admins']['login'][$idx]] = $entryArray[$idx];
					} else {
						// Rewrite regular entry
						$cacheArray['admins'][$key][$idMap[$idx]] = $entryArray[$idx];
					}

					// Is the last entry reached?
					if ($idx == 0) {
						// Remove it
						unset($cacheArray['admins'][$key][0]);
					} // END - if
				} // END - if
			} // END - for
		} else {
			// Nope, cache file is corrupted!
			$cacheInstance->cache_destroy();
			unset($cacheArray['admins']);
		}
	} else {
		// Nope, cache file is corrupted!
		$cacheInstance->cache_destroy();
		unset($cacheArray['admins']);
	}
} elseif (($_CONFIG['cache_admins'] == "Y") && ($CSS != "1") && ($CSS != "-1")) {
	// Create cache file
	$cacheInstance->cache_init("ADMINS");
	$cacheInstance->store_extension_version("admins");

	// Load every data from DB to cache file
	$ADD = ", id, id";
	if (GET_EXT_VERSION("admins") >= "0.3")   $ADD  = ", default_acl AS def_acl";
	if (GET_EXT_VERSION("admins") >= "0.6.7") $ADD .= ", la_mode";
	if (GET_EXT_VERSION("admins") >= "0.7.0") $ADD .= ", login_failtures, UNIX_TIMESTAMP(last_failture) AS last_failture";

	// Query the database about this
	$result_admins = SQL_QUERY("SELECT id AS aid, login, password, email".$ADD."
FROM "._MYSQL_PREFIX."_admins
ORDER BY login", __FILE__, __LINE__);
	while($dummy = SQL_FETCHARRAY($result_admins)) {
		// Save row
		$cacheInstance->add_row($dummy);
	} // END - while

	// Free memory
	SQL_FREERESULT($result_admins);

	// Close cache
	$cacheInstance->cache_close();

	// Reload the cache
	require(__FILE__);
}

// Close file
$cacheInstance->cache_close();

// Next cached table are the admins_acls...
if (GET_EXT_VERSION("admins") >= "0.3") {
	// Check for cache file
	if (($cacheInstance->cache_file("admins_acls")) && ($cacheInstance->ext_version_matches("admins"))) {
		// Load referal system from cache
		global $cacheArray;
		$cacheArray['admin_acls'] = $cacheInstance->cache_load();
	} elseif (($_CONFIG['cache_acls'] == "Y") && ($CSS != "1") && ($CSS != "-1")) {
		// Create cache file here
		$cacheInstance->cache_init("ADMINS_ACLS");
		$cacheInstance->store_extension_version("admins");

		// Load all modules and their data
		$result = SQL_QUERY("SELECT id, admin_id, action_menu, what_menu, access_mode FROM "._MYSQL_PREFIX."_admins_acls ORDER BY admin_id, action_menu, what_menu", __FILE__, __LINE__);
		while ($data = SQL_FETCHARRAY($result)) {
			// Add row to cache file
			$cacheInstance->add_row($data);
		} // END - while

		// Free memory
		SQL_FREERESULT($result);

		// Reload the cache
		require(__FILE__);
	}

	// Close file
	$cacheInstance->cache_close();
} // END - if

//
?>
